#include <bits/stdc++.h>
#include <cmath>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n,q;
    cin>>n>>q;
    long long p[n],d[n];
    for(int i=0;i<n;i++)
    {
        cin>>d[i]>>p[i];
    }
    //nije dobro za test primere kada je npr plazmu ne moze da pojede do sledeceg d[i]
    for(int i=0;i<q;i++)
    {
        int k;
        cin>>k;
        long long ispis=0;
        int indeks_izmedju=lower_bound(d,d+n,k)-d;
        for(int j=0;j<indeks_izmedju;j++)
        {
          if(k>d[n-1]+p[n-1])
                ispis+=p[j];
           else
           {
                if(j==indeks_izmedju-1)
                    ispis+=abs(k-d[j]+1);
                else
                {
                    if(d[j+1]-d[j]>p[j])
                        ispis+=p[j];
                    else
                        ispis+=d[j+1]-d[j];
                }
           }
        }
        cout<<ispis<<endl;
    }
    return 0;
}